/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.testtransaction.model;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.List;

/**
 * This class is used by SOAP remote services.
 *
 * @author    Brian Wing Shun Chan
 * @generated
 */
public class BarSoap implements Serializable {
	public static BarSoap toSoapModel(Bar model) {
		BarSoap soapModel = new BarSoap();

		soapModel.setBarId(model.getBarId());
		soapModel.setText(model.getText());

		return soapModel;
	}

	public static BarSoap[] toSoapModels(Bar[] models) {
		BarSoap[] soapModels = new BarSoap[models.length];

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModel(models[i]);
		}

		return soapModels;
	}

	public static BarSoap[][] toSoapModels(Bar[][] models) {
		BarSoap[][] soapModels = null;

		if (models.length > 0) {
			soapModels = new BarSoap[models.length][models[0].length];
		}
		else {
			soapModels = new BarSoap[0][0];
		}

		for (int i = 0; i < models.length; i++) {
			soapModels[i] = toSoapModels(models[i]);
		}

		return soapModels;
	}

	public static BarSoap[] toSoapModels(List<Bar> models) {
		List<BarSoap> soapModels = new ArrayList<BarSoap>(models.size());

		for (Bar model : models) {
			soapModels.add(toSoapModel(model));
		}

		return soapModels.toArray(new BarSoap[soapModels.size()]);
	}

	public BarSoap() {
	}

	public long getPrimaryKey() {
		return _barId;
	}

	public void setPrimaryKey(long pk) {
		setBarId(pk);
	}

	public long getBarId() {
		return _barId;
	}

	public void setBarId(long barId) {
		_barId = barId;
	}

	public String getText() {
		return _text;
	}

	public void setText(String text) {
		_text = text;
	}

	private long _barId;
	private String _text;
}