/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.testtransaction.model.impl;

import com.liferay.portal.kernel.exception.SystemException;

import com.liferay.testtransaction.model.Bar;
import com.liferay.testtransaction.service.BarLocalServiceUtil;

/**
 * The extended model base implementation for the Bar service. Represents a row in the &quot;TT_Bar&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This class exists only as a container for the default extended model level methods generated by ServiceBuilder. Helper methods and all application logic should be put in {@link BarImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see BarImpl
 * @see com.liferay.testtransaction.model.Bar
 * @generated
 */
public abstract class BarBaseImpl extends BarModelImpl implements Bar {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a bar model instance should use the {@link Bar} interface instead.
	 */
	public void persist() throws SystemException {
		BarLocalServiceUtil.updateBar(this);
	}
}