/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.testtransaction.model.impl;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;

import com.liferay.testtransaction.model.Bar;

import java.io.Serializable;

/**
 * The cache model class for representing Bar in entity cache.
 *
 * @author Brian Wing Shun Chan
 * @see Bar
 * @generated
 */
public class BarCacheModel implements CacheModel<Bar>, Serializable {
	@Override
	public String toString() {
		StringBundler sb = new StringBundler(5);

		sb.append("{barId=");
		sb.append(barId);
		sb.append(", text=");
		sb.append(text);
		sb.append("}");

		return sb.toString();
	}

	public Bar toEntityModel() {
		BarImpl barImpl = new BarImpl();

		barImpl.setBarId(barId);

		if (text == null) {
			barImpl.setText(StringPool.BLANK);
		}
		else {
			barImpl.setText(text);
		}

		barImpl.resetOriginalValues();

		return barImpl;
	}

	public long barId;
	public String text;
}