/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.testtransaction.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import com.liferay.testtransaction.model.Bar;
import com.liferay.testtransaction.model.BarModel;

import java.io.Serializable;

import java.sql.Types;

/**
 * The base model implementation for the Bar service. Represents a row in the &quot;TT_Bar&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link com.liferay.testtransaction.model.BarModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link BarImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see BarImpl
 * @see com.liferay.testtransaction.model.Bar
 * @see com.liferay.testtransaction.model.BarModel
 * @generated
 */
public class BarModelImpl extends BaseModelImpl<Bar> implements BarModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a bar model instance should use the {@link com.liferay.testtransaction.model.Bar} interface instead.
	 */
	public static final String TABLE_NAME = "TT_Bar";
	public static final Object[][] TABLE_COLUMNS = {
			{ "barId", Types.BIGINT },
			{ "text_", Types.VARCHAR }
		};
	public static final String TABLE_SQL_CREATE = "create table TT_Bar (barId LONG not null primary key,text_ VARCHAR(75) null)";
	public static final String TABLE_SQL_DROP = "drop table TT_Bar";
	public static final String ORDER_BY_JPQL = " ORDER BY bar.text ASC";
	public static final String ORDER_BY_SQL = " ORDER BY TT_Bar.text_ ASC";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.com.liferay.testtransaction.model.Bar"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.com.liferay.testtransaction.model.Bar"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.column.bitmask.enabled.com.liferay.testtransaction.model.Bar"),
			true);
	public static long TEXT_COLUMN_BITMASK = 1L;
	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.com.liferay.testtransaction.model.Bar"));

	public BarModelImpl() {
	}

	public long getPrimaryKey() {
		return _barId;
	}

	public void setPrimaryKey(long primaryKey) {
		setBarId(primaryKey);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_barId);
	}

	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	public Class<?> getModelClass() {
		return Bar.class;
	}

	public String getModelClassName() {
		return Bar.class.getName();
	}

	public long getBarId() {
		return _barId;
	}

	public void setBarId(long barId) {
		_barId = barId;
	}

	public String getText() {
		if (_text == null) {
			return StringPool.BLANK;
		}
		else {
			return _text;
		}
	}

	public void setText(String text) {
		_columnBitmask |= TEXT_COLUMN_BITMASK;

		if (_originalText == null) {
			_originalText = _text;
		}

		_text = text;
	}

	public String getOriginalText() {
		return GetterUtil.getString(_originalText);
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public Bar toEscapedModel() {
		if (_escapedModelProxy == null) {
			_escapedModelProxy = (Bar)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelProxyInterfaces,
					new AutoEscapeBeanHandler(this));
		}

		return _escapedModelProxy;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		if (_expandoBridge == null) {
			_expandoBridge = ExpandoBridgeFactoryUtil.getExpandoBridge(0,
					Bar.class.getName(), getPrimaryKey());
		}

		return _expandoBridge;
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		getExpandoBridge().setAttributes(serviceContext);
	}

	@Override
	public Object clone() {
		BarImpl barImpl = new BarImpl();

		barImpl.setBarId(getBarId());
		barImpl.setText(getText());

		barImpl.resetOriginalValues();

		return barImpl;
	}

	public int compareTo(Bar bar) {
		int value = 0;

		value = getText().compareTo(bar.getText());

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		Bar bar = null;

		try {
			bar = (Bar)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long primaryKey = bar.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public void resetOriginalValues() {
		BarModelImpl barModelImpl = this;

		barModelImpl._originalText = barModelImpl._text;

		barModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<Bar> toCacheModel() {
		BarCacheModel barCacheModel = new BarCacheModel();

		barCacheModel.barId = getBarId();

		barCacheModel.text = getText();

		String text = barCacheModel.text;

		if ((text != null) && (text.length() == 0)) {
			barCacheModel.text = null;
		}

		return barCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(5);

		sb.append("{barId=");
		sb.append(getBarId());
		sb.append(", text=");
		sb.append(getText());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(10);

		sb.append("<model><model-name>");
		sb.append("com.liferay.testtransaction.model.Bar");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>barId</column-name><column-value><![CDATA[");
		sb.append(getBarId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>text</column-name><column-value><![CDATA[");
		sb.append(getText());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static ClassLoader _classLoader = Bar.class.getClassLoader();
	private static Class<?>[] _escapedModelProxyInterfaces = new Class[] {
			Bar.class
		};
	private long _barId;
	private String _text;
	private String _originalText;
	private transient ExpandoBridge _expandoBridge;
	private long _columnBitmask;
	private Bar _escapedModelProxy;
}